getSymbols("AAPL", from = '2014-01-10',
           to = "2022-03-01",warnings = FALSE,
           auto.assign = TRUE)
length(AAPL)

#######################################################################

HurstN <- function(k){
  Hurstnormk = numeric()
  HK = numeric()
  H.koef = numeric()
  RkuS = numeric()      #globln, sem si ukldm zprm. hodnoty rkus
  Hurstnormk <- 0
  H.koef <- 0
  Hurst <- 0
  for(j in 1:k) # vygeneruje 2048 hodnot, spote HK a to provede k.krt
  {
    set.seed(j)
    N <- 2^11
    X <- ts(rnorm(N,0,1)) #ts[1:2048] 
    length(X)
    n.seznam = N/(2^(0:11))
    #ts.plot(X) 
    for (i in 1:length(n.seznam)) # jedu pes 4 seky dlky N/4 a na konci zprmruju
    {
      n = n.seznam[i] 
      R = 0; S=0; rkus=0      #Pi kadm prchodu nejdve vynuluji
      
      for (ii in 1:i)
      {
        x = X[(ii-1)*n+1:n]
        y = x-mean(x)
        z = cumsum(y)
        R[ii]    = max(z)-min(z)
        S[ii]    = sd(x)
        rkus[ii] = R[ii]/S[ii]        #ty, kter budu prmrovat
      }
      
      RkuS[i] = mean(rkus)  #Zprmruju pes vechny dl ady dan dlky
    }
    n.seznam = rev(n.seznam)  #pevrtm to, aby to lo popodku  
    RkuS     = rev(RkuS)
    
    #plot(log2(RkuS)~log2(n.seznam))
    m = lm(log2(RkuS)~log2(n.seznam))
    H.koef[j] = as.numeric(coef(m)[2])
    Hurstnormk[j] <- H.koef[j]
  }
  return(Hurstnormk)    ##Jak se tu d udlat aby i to vyhodilo hodtu i boxplot?
} 
HurstN(10)
#Tato funkce nm vrt pro k sri nhodnho generovn 2048 hodnot pro k vsledk Hurstova koeficientu
par(mfrow=c(1,1))
#Zde si vykreslme boxploty pro 10, 100, 500, 1000 generovn
box1 <- HurstN(10)    #pro 10 sri generovn
box2 <- HurstN(100)
box3 <- HurstN(500)   #pro 100 sri generovn
box4 <- HurstN(1000)
data <- data.frame('10' = box1,
                   '100' = box2,
                   '500' = box3,
                  '1000' = box4)
boxplot(data)       #boxploty pro kadou vstupn hodnotu z Hurst1, pro k = 10, 100, 500, 1000
head(data)

df9 <- data.frame(values = data)
write.csv(df9, file = "Boxploty.csv")


#################################################################################################
#Pro poty nagenerovanch hodnot 2^k, dlen intervalu stle 2^(0:11)
HurstNL <- function(k)
  {
    Hurstnormk = numeric()
    H.koef = numeric()
    RkuS = numeric()      #globln, sem si ukldm zprm. hodnoty rkus
    Hurstnormk <- 0
    H.koef <- 0
    Hurst <- 0
      N <- 2^k
      X <- ts(rnorm(N,0,1)) #ts[1:2048] 
      length(X)
      n.seznam = N/(2^(0:11))
      #ts.plot(X) 
      for (i in 1:length(n.seznam)) # jedu pes 4 seky dlky N/4 a na konci zprmruju
      {
        n = n.seznam[i] 
        R = 0; S=0; rkus=0      #Pi kadm prchodu nejdve vynuluji
        
        for (ii in 1:i)
        {
          x = X[(ii-1)*n+1:n]
          y = x-mean(x)
          z = cumsum(y)
          R[ii]    = max(z)-min(z)
          S[ii]    = sd(x)
          rkus[ii] = R[ii]/S[ii]        #ty, kter budu prmrovat
        }
        
        RkuS[i] = mean(rkus)  #Zprmruju pes vechny dl ady dan dlky
      }
      n.seznam = rev(n.seznam)  #pevrtm to, aby to lo popodku  
      RkuS     = rev(RkuS)
      
      #plot(log2(RkuS)~log2(n.seznam))
      m = lm(log2(RkuS)~log2(n.seznam))
      H.koef = as.numeric(coef(m)[2])
      Hurstnormk <- H.koef
      return(Hurstnormk)    ##Jak se tu d udlat aby i to vyhodilo hodtu i boxplot?
  } 
HurstNL(10)
#Hurst pro poty nagenerovanch hodnot 2^(8:13)

HurstPlot <- 0
for (j in 8:20)
  {
HurstPlot[j-7] <- HurstNL(j)
  }
HurstPlot

df7 <- data.frame(values = HurstPlot)
write.csv(df7, file = "Hurstplot.csv")


par(mfrow=c(1,2))
plot(type="l", HurstPlot) #vykreslme si to v grafu
plot(HurstPlot)
par(mfrow=c(1,1))

################# Popsat jet
HurstI <- function(k)
{
  Hurstnormk = numeric()
  H.koef = numeric()
  RkuS = numeric()      #globln, sem si ukldm zprm. hodnoty rkus
  Hurstnormk <- 0
  H.koef <- 0
  Hurst <- 0
  N <- 2^k
  X <- ts(rnorm(N,0,1)) #ts[1:2048] 
  length(X)
  n.seznam = N/(2^(0:k))
  #ts.plot(X) 
  for (i in 1:length(n.seznam)) # jedu pes 4 seky dlky N/4 a na konci zprmruju
  {
    n = n.seznam[i] 
    R = 0; S=0; rkus=0      #Pi kadm prchodu nejdve vynuluji
    
    for (ii in 1:i)
    {
      x = X[(ii-1)*n+1:n]
      y = x-mean(x)
      z = cumsum(y)
      R[ii]    = max(z)-min(z)
      S[ii]    = sd(x)
      rkus[ii] = R[ii]/S[ii]        #ty, kter budu prmrovat
    }
    
    RkuS[i] = mean(rkus)  #Zprmruju pes vechny dl ady dan dlky
  }
  n.seznam = rev(n.seznam)  #pevrtm to, aby to lo popodku  
  RkuS     = rev(RkuS)
  
  #plot(log2(RkuS)~log2(n.seznam))
  m = lm(log2(RkuS)~log2(n.seznam))
  H.koef = as.numeric(coef(m)[2])
  Hurstnormk <- H.koef
  return(Hurstnormk)    ##Jak se tu d udlat aby i to vyhodilo hodtu i boxplot?
} 
HurstI(9)
#Hurst pro poty nagenerovanch hodnot 2^(8:18)
HurstPlot <- 0
par(mfrow=c(1,2))
for (j in 8:17)
{
  HurstPlot[j-7] <- HurstI(j)
}
HurstPlot

df7 <- data.frame(values = HurstPlot)
write.csv(df7, file = "HurstI.csv")

?plot
plot(HurstPlot) #vykreslme si to v grafu

axis(1, at=seq(1,10,by=2),labels=c("2^8","2^10","2^12","2^14","2^16"))
axis(2, at=seq(0.5,0.7,by=0.05))
plot(HurstPlot, xlab="poet generovn = 2^8 a 2^17", ylab="Hurst")

#Boxplot pro Hurst.k.
Hurstbox <- function(k)
{
  Hurstnormk <- 0
  HK = numeric()
  H.koef = numeric()
  RkuS = numeric()     
  H.koef <- 0
  Hurst <- 0
  for(j in 1:k) 
  {
    set.seed(j)
    N <- 2^11
    X <- ts(rnorm(N,0,1)) #ts[1:2048] 
    n.seznam = N/(2^(0:11))
    for (i in 1:length(n.seznam)) 
    {
      n = n.seznam[i] 
      R = 0; S=0; rkus=0      
      
      for (ii in 1:i)
      {
        x = X[(ii-1)*n+1:n]
        y = x-mean(x)
        z = cumsum(y)
        R[ii]    = max(z)-min(z)
        S[ii]    = sd(x)
        rkus[ii] = R[ii]/S[ii]        
      }
      
      RkuS[i] = mean(rkus)  
    }
    n.seznam = rev(n.seznam)  
    RkuS     = rev(RkuS)
    
    # plot(log2(RkuS)~log2(n.seznam))
    m = lm(log2(RkuS)~log2(n.seznam))
    H.koef[j] = as.numeric(coef(m)[2])
    Hurstnormk[j] <- H.koef[j]
  }
  return(boxplot(Hurstnormk))
}
j
par(mfrow=c(1,1))
Hurstbox(30)
summary(Hurstbox(30))
?paste
?plot
?par
rm(Hurstk)
HurstN(20)
